%macro projdum(from=,templib=,i=,t=,weight=,store=);
libname wk &templib;
%put Sort and get nT and nN;
proc sort data=&from out=wk.sorted; by &i &t;
proc sort data=wk.sorted out=wk.indT (keep=&t) nodupkey; by &t; 
data wk.indT; set wk.indT; tindex=_n_; call symput('nT',_N_);
proc sort data=wk.sorted out=wk.indN (keep=&i) nodupkey; by &i;
data wk.indN; set wk.indN; call symput('nN',_N_);
* There has to be a better way to do this (merge a long data-set with a short one without sorting the long one);
	proc sort data=&from out=wk.sorted; by &t &i;
	data wk.sorted; merge wk.sorted wk.indT; by &t;
%put Construct wk.sorted; 
proc sort data=wk.sorted(drop=&t); by &i tindex;

%put Add up weights;
data wk.currvar ; 
	set wk.sorted (keep=&i tindex &weight); 
	retain previ prevt prevw;
	if previ=&i and prevt=tindex then addw=&weight+prevw;
	else addw=&weight;
	prevw=addw; previ=&i; prevt=tindex;
	run;
	
*proc print data=wk.currvar (obs=100);

data wk.currvar; set wk.currvar (drop=prevw previ prevt);
%put Data wk.currvar is the original data wk.currvar by &i and tindex; 
%put Obtain matrix with weights;
proc transpose data=wk.currvar out=wk.transposed prefix=Col let;
    by &i;
    id tindex;
    var addw;
run;

data wk.parameters;
lastColumn="Col&nT";
lastColumn=compress(lastColumn);
call symput('lastColumn',lastColumn);
nT=&nT;
nN=&nN;
hhid="&i";
weight="&weight";
output;
run;

data wk.transposed;
set wk.transposed;
array hrx {&nT} Col1-&lastColumn;
do hr=1 to &nT;
if hrx{hr}=. then hrx{hr}=0;
end; run;

%put 2: Obtain the inverse in the dummy regression projection matrix: need to specify the two ways dummies and the weights: also the range of variables, library donden las matrices;
proc iml symsize=25000 worksize=25000;
RESET STORAGE=&store;
use wk.transposed;
read all var ('Col1':"&lastColumn") into DH;
read all var ("&i") into cid;
DH12=DH##(1/2);
store DH12; free DH12;
HH=DH[+,]; 
DD=DH[,+]; 
%IF &nN>&nT %THEN %DO;
	HH=HH[1:NCOL(HH)-1];
	DH=DH[,1:NROW(HH)];
	C=inv(diag(HH)-t(DH)*diag(DD##(-1))*DH);
	B=-diag(DD##(-1))*DH*C;
	store DD HH DH C B; free DD HH DH C B;
	%END; 
	%ELSE %DO;
	DD=DD[1:NROW(DD)-1];
	DH=DH[1:NROW(DD),];
	A=inv(diag(DD)-DH*diag(HH##(-1))*t(DH));
	B=-diag(HH##(-1))*t(DH)*A;
	store DD HH DH A B; free DD HH DH A B;
	%END; 
quit;
%mend;


*3. Get coefficients: need to specify which variable is the dependent and which are the explanatory variables.;
%macro vartoinc(templib=,store=,vars=);
libname wk &templib;
data _null_;
set wk.parameters;
call symput('lastColumn',lastColumn);
call symput('nT',nT);
call symput('nN',nN);
call symput('i',hhid);
call symput('weight',weight);
run;

DATA variables;  
   length long_str $ 512; 
long_str="&vars";
output;
run;
*proc print data=variables;
data variables;
set variables;
long_str=COMPBL(long_str);
total=LENGTH(long_str);
compress1=compress(long_str);
comp1=LENGTH(compress1);
words=total-comp1+1;
call symput('numvar',words);
run;

%DO nvar=1 %TO &numvar;
data variables;
set variables;
currvar=scan(long_str,&nvar,' ');
currvar=compress(currvar);
call symput('currvar',currvar);
*lastColumn="&lastColumn";
run;

%put Add up weights;
data wk.currvar ; 
	set wk.sorted (keep=&i tindex &weight &currvar); 
	retain previ prevt preav prevsw;
	if previ=&i and prevt=tindex then do;
		addsw=&weight+prevsw;
		avvar=(preav*prevsw+&currvar*&weight)/addsw;		
		end;
	else do;
		addsw=&weight;
		avvar=&currvar;
		end;
	prevsw=addsw; previ=&i; prevt=tindex; preav=avvar;
	run;

data wk.currvar; set wk.currvar(drop=prevsw previ prevt preav);

proc transpose data=wk.currvar out=wk.transposed prefix=Col let;
    by &i;
    id tindex;
    var avvar;
run;

data del;
str="Col&nT";
str=compress(str);
call symput('lastColumn',str);
nT=&nT;
output;
run;

data wk.transposed;
set wk.transposed;
array hrx {&nT} Col1-&lastColumn;
do hr=1 to &nT;
if hrx{hr}=. then hrx{hr}=0;
end; run;
	
proc iml symsize=25000 worksize=25000;
RESET STORAGE=&store;
use wk.transposed;
read all var ('Col1':"&lastColumn") into Y;
TY=Y[+,];
DY=Y[,+];
%IF &nN>&nT %THEN %DO;
	TY=TY[1:NCOL(TY)-1];
	load DD HH DH C B;
	delta0=diag(DD##(-1))*DY+diag(DD##(-1))*DH*C*t(DH)*diag(DD##(-1))*DY+B*TY;
	tau0=t(B)*DY+C*TY;
	%END;
	%ELSE %DO;
	DY=DY[1:NROW(DD)-1];
	load DD HH DH A B;
	delta0=A*DY+B*TY;
	tau0=t(B)*DY+diag(HH##(-1))*TY+diag(HH##(-1))*t(DH)*A*DH*diag(HH##(-1))*TY;
	%END; 
	create wk.delta from delta0 [colname={"delta"}];
	append from delta0;
	create wk.tau from tau0 [colname={"tau"}];
	append from tau0;
quit;

*proc means data=wk.parameters; Title 'parameters';
*proc means data=wk.delta; Title 'delta';
*proc means data=wk.indN; Title 'indN';
*proc means data=wk.tau; Title 'tau';
*proc means data=wk.indT; Title 'indT';

data wk.delta; merge wk.delta wk.indN; if delta=. then delta=0;
data wk.tau; merge wk.tau wk.indT; if tau=. then tau=0;
data wk.currvar; merge wk.currvar wk.delta; by &i;
proc sort data=wk.currvar; by tindex;
data wk.currvar; merge wk.currvar wk.tau; by tindex;
proc sort data=wk.currvar; by &i tindex;
data wk.sorted; merge wk.sorted wk.currvar; by &i tindex;
*proc contents data=wk.sorted;
data wk.sorted; set wk.sorted; &currvar=(&currvar-delta-tau)*SQRT(&weight); run;
*missing observations??;
%end;
data wk.plus; set wk.sorted; keep &i tindex &vars &weight; run;
%mend;

%macro regress(templib=,dep=,expl=,cluster=);
libname wk &templib;
*proc reg data=wk.plus;
*model &dep=&expl /noint;
*run;
*quit;

*proc means data=wk.plus;
proc print data=wk.plus (obs=10);


proc surveyreg data=wk.plus;
 cluster &cluster;
 model &dep = &expl /solution noint; run;
 *vadjust=none;
quit;

%mend;

